---
title: Apply Promotions
slug: api-documentation/apply-promotions
docTags: 
createdAt: 2026-08-27T17:06:56.421Z
---

{
  "id": "gIbvrq1lKDfnfPjKbKnMr",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.upstartcommerce.com/v1/promotion/apply",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/v1/promotion/apply"
      }
    ],
    "name": "Apply Promotions",
    "description": "<p>This endpoint allows administrators to apply promotions to a consumer's cart.</p>\n<p>Authorized permissions:</p>\n<ul>\n<li><code>promotion.update</code></li>\n</ul>\n<p>Authorized roles:</p>\n<ul>\n<li>customer.default</li>\n<li>customer.anonymous</li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "kind": "required",
          "name": "x-upstart-tenant",
          "type": "string",
          "description": "Tenant identifier associated with the site this call is for."
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "ApplyPromotionsRequest",
          "schema": [
            {
              "name": "cartId",
              "kind": "required",
              "type": "string<uuid>",
              "description": "Unique identifier for cart.",
              "format": "uuid"
            },
            {
              "name": "originSiteId",
              "kind": "required",
              "type": "string",
              "description": "Site associated with the promotions."
            },
            {
              "name": "created",
              "kind": "optional",
              "type": "string<date-time>",
              "description": "",
              "format": "date-time"
            },
            {
              "name": "promotions",
              "kind": "required",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/ApplyPromotion",
              "customType": "ApplyPromotion[]",
              "schema": [
                {
                  "name": "couponId",
                  "kind": "optional",
                  "type": "string",
                  "description": "<p>Unique identifier for coupon (coupon code).</p>"
                },
                {
                  "name": "promotionId",
                  "kind": "required",
                  "type": "string",
                  "description": ""
                }
              ]
            }
          ],
          "modelRef": "#/components/schemas/ApplyPromotionsRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "NoChannelPortalAccess",
          "name": "NoChannelPortalAccess",
          "kind": "optional",
          "type": "http",
          "description": "<p>This authentication is required for clients to interact with any of the management APIs. Similar to 'LoggedIn', it indicates that the user has actually logged into the system, but in this case with a management role.</p>",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "<p>Success-promotion/s applied.</p>",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "400",
        "description": "The request contained information that the server was unable to process. Appropriate errors are provided in the response body.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ValidationErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ValidationErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "Iqiuv2kFTgj29IQ_9e6Gz",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.upstartcommerce.com/v1/promotion/apply \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --header 'x-upstart-tenant: string' \\\n     --data '{\n     \"cartId\": \"\",\n     \"originSiteId\": \"\",\n     \"promotions\": [\n     {\n     \"promotionId\": \"\"\n     }\n     ]\n     }'"
        },
        {
          "id": "tQxyllnz9lw0r0ABFjznR",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\nmyHeaders.append(\"x-upstart-tenant\", \"string\");\n\nvar raw = JSON.stringify({\n   \"cartId\": \"\",\n   \"originSiteId\": \"\",\n   \"promotions\": [\n      {\n         \"promotionId\": \"\"\n      }\n   ]\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/v1/promotion/apply\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "5FdamM9Ho-DF7o8PTO-25",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/v1/promotion/apply\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest[\"x-upstart-tenant\"] = \"string\"\nrequest.body = JSON.dump({\n   \"cartId\": \"\",\n   \"originSiteId\": \"\",\n   \"promotions\": [\n      {\n         \"promotionId\": \"\"\n      }\n   ]\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "Dut7IPbeSWUF6MOa-PL9u",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/v1/promotion/apply\"\n\npayload = json.dumps({\n   \"cartId\": \"\",\n   \"originSiteId\": \"\",\n   \"promotions\": [\n      {\n         \"promotionId\": \"\"\n      }\n   ]\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json',\n   'x-upstart-tenant': 'string'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "Iqiuv2kFTgj29IQ_9e6Gz"
    },
    "results": {
      "languages": [
        {
          "id": "FojGRBugTWAzmqQzEyrrB",
          "language": "200",
          "code": "// Success-promotion/s applied.\n"
        },
        {
          "id": "X5j9CiG_Wnlm782euN8k_",
          "language": "400",
          "code": "// The request contained information that the server was unable to process. Appropriate errors are provided in the response body.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\"\n}"
        },
        {
          "id": "mik-1DydWUKxGZI2W81ur",
          "language": "401",
          "code": "// The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "FojGRBugTWAzmqQzEyrrB"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}